1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
67 elif [ -f ..
/aptconfig.conf
]; then
68 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
70 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
73 aptconfig
() { runapt apt
-config $
*; }
74 aptcache
() { runapt apt
-cache $
*; }
75 aptget
() { runapt apt
-get $
*; }
76 aptftparchive
() { runapt apt
-ftparchive $
*; }
77 aptkey
() { runapt apt
-key $
*; }
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
82 if [ -f .
/aptconfig.conf
]; then
83 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
84 elif [ -f ..
/aptconfig.conf
]; then
85 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
87 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
92 TMPWORKINGDIRECTORY
=$(mktemp -d)
93 local TESTDIR
=$(readlink -f $(dirname $0))
94 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
95 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
96 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
97 local OLDWORKINGDIRECTORY
=$(pwd)
98 CURRENTTRAP
="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
99 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
100 cd $TMPWORKINGDIRECTORY
101 mkdir rootdir aptarchive keys
103 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
104 mkdir -p var
/cache var
/lib var
/log
105 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
106 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
107 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
108 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
110 touch var/lib/dpkg/status
112 touch var/lib/dpkg/available
114 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
116 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
117 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
118 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
120 local SOURCESSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
121 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
122 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
124 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
125 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
126 echo "Dir
\"${TMPWORKINGDIRECTORY}/rootdir
\";" > aptconfig.conf
127 echo "Dir
::state
::status
\"${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
/status
\";" >> aptconfig.conf
128 echo "Debug
::NoLocking
\"true
\";" >> aptconfig.conf
129 echo "APT
::Get
::Show
-User-Simulation-Note \"false
\";" >> aptconfig.conf
130 echo "Dir
::Bin
::Methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
131 echo "Dir
::Bin
::dpkg
\"fakeroot
\";" >> aptconfig.conf
132 echo "DPKG
::options
:: \"dpkg
\";" >> aptconfig.conf
133 echo "DPKG
::options
:: \"--root=${TMPWORKINGDIRECTORY}/rootdir
\";" >> aptconfig.conf
134 echo "DPKG
::options
:: \"--force-not-root\";" >> aptconfig.conf
135 echo "DPKG
::options
:: \"--force-bad-path\";" >> aptconfig.conf
136 echo "DPKG
::options
:: \"--log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
\";" >> aptconfig.conf
137 echo 'quiet::NoUpdate "true
";' >> aptconfig.conf
142 configarchitecture() {
143 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
144 echo "APT
::Architecture
\"$1\";" > $CONFFILE
146 while [ -n "$1" ]; do
147 echo "APT
::Architectures
:: \"$1\";" >> $CONFFILE
152 setupsimplenativepackage() {
156 local RELEASE="${4:-unstable}"
157 local DEPENDENCIES="$5"
158 local DESCRIPTION="$6"
159 local SECTION="${7:-others}"
161 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
164 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
166 local BUILDDIR=incoming/${NAME}-${VERSION}
167 mkdir -p ${BUILDDIR}/debian/source
169 echo "* most suckless software product ever
" > FEATURES
170 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
171 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
175 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
176 test -e debian/control || echo "Source
: $NAME
179 Maintainer
: Joe Sixpack
<joe@example.org
>
180 Build
-Depends: debhelper
(>= 7)
181 Standards
-Version: 3.9.1
184 Architecture
: $ARCH" > debian/control
185 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
186 if [ -z "$DESCRIPTION" ]; then
187 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
188 If you
find such a package installed on your system
,
189 YOU did something horribly wrong
! They are autogenerated
190 und used only by testcases
for APT and surf no other propose…
" >> debian/control
192 echo "Description
: $DESCRIPTION" >> debian/control
194 test -e debian/compat || echo "7" > debian/compat
195 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
196 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
200 buildsimplenativepackage() {
204 local RELEASE="${4:-unstable}"
205 local DEPENDENCIES="$5"
206 local DESCRIPTION="$6"
207 local SECTION="${7:-others}"
209 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
212 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
214 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
215 buildpackage "incoming
/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
216 rm -rf "incoming
/${NAME}-${VERSION}"
223 msgninfo "Build package
$(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}…
"
225 if [ "$ARCH" = "all
" ]; then
226 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
228 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
229 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
230 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
233 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
236 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
242 if [ -d incoming ]; then
243 buildaptarchivefromincoming $*
245 buildaptarchivefromfiles $*
249 createaptftparchiveconfig() {
250 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
251 if [ -z "$ARCHS" ]; then
252 # the pool is empty, so we will operate on faked packages - let us use the configured archs
253 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
256 ArchiveDir "' >> ftparchive.conf
257 echo -n $(readlink -f .) >> ftparchive.conf
259 CacheDir "' >> ftparchive.conf
260 echo -n $(readlink -f ..) >> ftparchive.conf
262 FileListDir "' >> ftparchive.conf
263 echo -n $(readlink -f pool/) >> ftparchive.conf
267 Packages::Compress ". gzip bzip2 lzma";
268 Sources::Compress ". gzip bzip2 lzma";
269 Contents::Compress ". gzip bzip2 lzma";
273 SrcDirectory "pool/";
279 Label "apttestcases";
281 Description "repository with dummy packages";
282 Architectures "' >> ftparchive.conf
283 echo -n "$ARCHS" >> ftparchive.conf
287 };' >> ftparchive.conf
288 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
289 echo -n 'tree "dists/' >> ftparchive.conf
290 echo -n "$DIST" >> ftparchive.conf
292 Architectures "' >> ftparchive.conf
293 echo -n "$ARCHS" >> ftparchive.conf
295 FileList "' >> ftparchive.conf
296 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
298 SourceFileList "' >> ftparchive.conf
299 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
301 Sections "' >> ftparchive.conf
302 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
304 };' >> ftparchive.conf
308 buildaptftparchivedirectorystructure
() {
309 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
310 for DIST
in $DISTS; do
311 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
312 for SECTION
in $SECTIONS; do
313 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
314 for ARCH
in $ARCHS; do
315 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
317 mkdir -p dists
/${DIST}/${SECTION}/source
318 mkdir -p dists
/${DIST}/${SECTION}/i18n
328 local DEPENDENCIES
="$5"
330 if [ "$ARCHS" = "all" ]; then
331 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
333 for BUILDARCH
in $ARCHS; do
334 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
335 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
336 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
337 local FILE
="${PPATH}/Packages"
342 Maintainer: Joe Sixpack <joe@example.org>
345 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
346 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
347 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
348 If you find such a package installed on your system,
349 YOU did something horribly wrong! They are autogenerated
350 und used only by testcases for APT and surf no other propose…
355 buildaptarchivefromincoming
() {
356 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
358 [ -e pool
] || ln -s ..
/incoming pool
359 [ -e ftparchive.conf
] || createaptftparchiveconfig
360 [ -e dists
] || buildaptftparchivedirectorystructure
361 msgninfo
"\tGenerate Packages, Sources and Contents files… "
362 aptftparchive
-qq generate ftparchive.conf
368 buildaptarchivefromfiles
() {
369 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
370 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
371 msgninfo
"\t${line} file… "
372 cat ${line} | gzip > ${line}.gz
373 cat ${line} | bzip2 > ${line}.bz2
374 cat ${line} | lzma
> ${line}.lzma
380 generatereleasefiles
() {
381 msgninfo
"\tGenerate Release files… "
382 if [ -e aptarchive
/dists
]; then
383 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
384 local CODENAME
="$(echo "$dir" | cut -d'/' -f 4)"
385 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Suite
="${CODENAME}" -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
386 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
388 NotAutomatic: yes' $dir/Release
392 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
397 setupdistsaptarchive
() {
398 local APTARCHIVE
=$(readlink -f ./aptarchive)
399 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
400 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
401 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
402 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
403 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
404 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
405 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
410 setupflataptarchive
() {
411 local APTARCHIVE
=$(readlink -f ./aptarchive)
412 if [ -f ${APTARCHIVE}/Packages
]; then
413 msgninfo
"\tadd deb sources.list line… "
414 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
417 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
419 if [ -f ${APTARCHIVE}/Sources
]; then
420 msgninfo
"\tadd deb-src sources.list line… "
421 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
424 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
430 if [ -e aptarchive
/dists
]; then
436 msgninfo
"\tSync APT's cache with the archive… "
442 local SIGNER
="${1:-Joe Sixpack}"
443 msgninfo
"\tSign archive with $SIGNER key… "
445 for KEY
in $(find keys/ -name '*.sec'); do
446 SECKEYS
="$SECKEYS --secret-keyring $KEY"
449 for KEY
in $(find keys/ -name '*.pub'); do
450 PUBKEYS
="$PUBKEYS --keyring $KEY"
452 for RELEASE
in $(find aptarchive/ -name Release); do
453 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
458 changetowebserver
() {
459 if which weborf
> /dev
/null
; then
460 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
461 CURRENTTRAP
="kill $!; $CURRENTTRAP"
462 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
463 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
464 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
465 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
473 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
474 if [ -n "$DIFFTEXT" ]; then
486 msgtest
"Test for correctness of file" "$FILE"
488 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
490 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
495 local COMPAREFILE
=$(mktemp)
496 echo "$1" > $COMPAREFILE
498 msgtest
"Test for equality of" "$*"
499 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
504 local COMPAREFILE1
=$(mktemp)
505 local COMPAREFILE2
=$(mktemp)
506 local COMPAREAGAINST
=$(mktemp)
507 echo "$1" > $COMPAREFILE1
508 echo "$2" > $COMPAREFILE2
510 msgtest
"Test for equality OR of" "$*"
511 $
* 2>&1 1> $COMPAREAGAINST
512 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
513 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
514 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
515 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
517 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
521 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
524 while [ -n "$1" ]; do
526 N: Can't select versions from package '$1' as it purely virtual"
527 PACKAGE
="${PACKAGE} $1"
530 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
532 N: No packages found"
533 local COMPAREFILE
=$(mktemp)
534 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
535 eval `apt-config shell ARCH APT::Architecture`
536 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
537 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
542 msgtest
"Test for non-existent packages" "apt-cache show $*"
543 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
544 if [ -n "$SHOWPKG" ]; then
553 testdpkginstalled
() {
554 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
555 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
556 if [ "$PKGS" != 0 ]; then
558 dpkg
-l $
* | grep '^[a-z]'
565 testdpkgnoninstalled
() {
566 msgtest
"Test for correctly non-installed package(s) with" "dpkg -l $*"
567 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
568 if [ "$PKGS" != 0 ]; then
570 dpkg
-l $
* | grep '^[a-z]'